import cv, os, Image, numpy, string, time
##import sqlite3

tmp_image = '../tmp/tmp/tmp.tif'
tmp_db = '../tmp/tmp/tmp.tif.db'
tmp_lock = '../tmp/tmp/tmp.tif.lock'
tmp_letter = '../tmp/tmp/tmp.tif.letter'
tmp_click = '../tmp/tmp/tmp.tif.click'
tmp_ended = '../tmp/tmp/tmp.ended'
# ==== Functions
single_click = {'last_click' : 0, 'coord' : (-1,-1)}
def on_mouse (event, x, y, flags, single_click):	# the callback
	if event == cv.CV_EVENT_LBUTTONDOWN:
		#print (x,y)
		f=open(tmp_click+'1', 'w')
		f.write('c %s %s' % (str(x), str(y)))
		f.close()
		os.rename(tmp_click+'1', tmp_click)
		single_click['last_click'] = time.time()
	if flags == cv.CV_EVENT_FLAG_LBUTTON and (time.time()-single_click['last_click'])>0.07:
		single_click['coord'] = (x,y)
		f=open(tmp_click+'1', 'w')
		f.write('m %s %s' % (str(x), str(y)))
		f.close()
		os.rename(tmp_click+'1', tmp_click)
	else :
		if single_click['coord'] != (-1, -1) :
			f=open(tmp_click+'1', 'w')
			f.write('m %s %s' % (str(-1), str(-1)))
			f.close()
			os.rename(tmp_click+'1', tmp_click)	
			single_click['coord'] = (-1, -1)
		else :
			pass

# ==== Main programe


##conn = sqlite3.connect(tmp_db)
##c = conn.cursor()
cv.NamedWindow ('Playback', cv.CV_WINDOW_AUTOSIZE)
cv.SetMouseCallback ('Playback', on_mouse, single_click)
print "DO NOT USE Ctrl-C to close this program, but hit ESCAPE"
print "Ctrl-C can lock all the display until cellTracking is restarted"
while 1 :
	##locked = c.execute('SELECT locked FROM movies WHERE i=0').fetchone()[0]
	locked = os.path.isfile(tmp_lock)
	#print locked
	if not locked and os.path.isfile(tmp_image):
		##c.execute('UPDATE movies SET locked=1 WHERE i=0')
		##conn.commit()
		open(tmp_lock, 'w').close()				# Locking file
		tmp = Image.open(tmp_image)
		try :
			os.remove(tmp_lock)
		except :
			pass
		##c.execute('UPDATE movies SET locked=0 WHERE i=0')
		##conn.commit()
		im = cv.GetImage(cv.fromarray(numpy.array(tmp)))
		cv.ShowImage('Playback', im)
		#print 'ok'
	key=cv.WaitKey(150)
	if chr(key&255) in string.letters :
		f=open(tmp_letter+'1', 'w')
		f.write(chr(key&255))
		f.close()
		os.rename(tmp_letter+'1', tmp_letter)
	if key==536870939 or key==27 or os.path.isfile(tmp_ended):
		break
try :
	os.remove(tmp_lock)
except :
	pass
##c.execute('UPDATE movies SET locked=0 WHERE i=0')
##conn.commit()


