# Example of virtual folder handling
# This function applies a threshold to the image

import re, os, cv
class Loader :
	def __init__(self, data) :
		self.loader_type = 'threshold'
		self.threshold = 10		# the threshold value
		self.source_channel = data['source_channel']	# The channel to be modified
		self.movie = data['movie']						# The source movie
		self.name_source = data['name_source']
		self.nb_files = self.movie.get_nb_frames()
	def update(self) :
		pass
	def get_loader_type(self) :
		"""The first value is 'is_inherited'"""
		return (True, self.loader_type)
		
	def init(self) :
		"""The final initialization"""
	def get_nb_frames(self) :
		return self.nb_files
	def get_frame_path(self, i) :
		print 'threshold module has no get_frame_path option'
	def get_frame_CV(self, i) :
		im = self.source_channel.loader.get_frame_CV(i)
		out = cv.CreateImage(cv.GetSize(im), im.depth, 3)
		cv.Copy(im, out)
		cv.Threshold(im, out, 60, 255, cv.CV_THRESH_BINARY)
		return out	# Return image
